diff -Naur openssl-1.0.0q.orig/crypto/evp/evp_pbe.c openssl-1.0.0q/crypto/evp/evp_pbe.c
--- openssl-1.0.0q.orig/crypto/evp/evp_pbe.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/evp_pbe.c	2017-04-25 16:23:40.356322099 +0200
@@ -56,20 +56,32 @@
  *
  */
 
+#ifdef LIBOPEAY_PKCS12_SUPPORT
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/evp.h>
 #include <openssl/pkcs12.h>
 #include <openssl/x509.h>
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 /* Password based encryption (PBE) functions */
 
 DECLARE_STACK_OF(EVP_PBE_CTL)
-static STACK_OF(EVP_PBE_CTL) *pbe_algs;
+#ifdef OPERA_SMALL_VERSION
+OPENSSL_IMPLEMENT_GLOBAL(STACK_OF(EVP_PBE_CTL) *, pbe_algs);
+#define pbe_algs OPENSSL_GLOBAL_REF(pbe_algs)
+#else
+static STACK_OF(EVP_PBE_CTL) *pbe_algs=NULL;
+#endif
 
 /* Setup a cipher context from a PBE algorithm */
 
-typedef struct
+typedef struct evp_pbe_ctl_st
 	{
 	int pbe_type;
 	int pbe_nid;
@@ -78,47 +90,58 @@
 	EVP_PBE_KEYGEN *keygen;
 	} EVP_PBE_CTL;
 
-static const EVP_PBE_CTL builtin_pbe[] = 
-	{
-	{EVP_PBE_TYPE_OUTER, NID_pbeWithMD2AndDES_CBC,
-			NID_des_cbc, NID_md2, PKCS5_PBE_keyivgen},
-	{EVP_PBE_TYPE_OUTER, NID_pbeWithMD5AndDES_CBC,
-			NID_des_cbc, NID_md5, PKCS5_PBE_keyivgen},
-	{EVP_PBE_TYPE_OUTER, NID_pbeWithSHA1AndRC2_CBC,
-			NID_rc2_64_cbc, NID_sha1, PKCS5_PBE_keyivgen},
-
-	{EVP_PBE_TYPE_OUTER, NID_pbe_WithSHA1And128BitRC4,
-			NID_rc4, NID_sha1, PKCS12_PBE_keyivgen},
-	{EVP_PBE_TYPE_OUTER, NID_pbe_WithSHA1And40BitRC4,
-			NID_rc4_40, NID_sha1, PKCS12_PBE_keyivgen},
-	{EVP_PBE_TYPE_OUTER, NID_pbe_WithSHA1And3_Key_TripleDES_CBC,
-		 	NID_des_ede3_cbc, NID_sha1, PKCS12_PBE_keyivgen},
-	{EVP_PBE_TYPE_OUTER, NID_pbe_WithSHA1And2_Key_TripleDES_CBC, 
-			NID_des_ede_cbc, NID_sha1, PKCS12_PBE_keyivgen},
-	{EVP_PBE_TYPE_OUTER, NID_pbe_WithSHA1And128BitRC2_CBC,
-			NID_rc2_cbc, NID_sha1, PKCS12_PBE_keyivgen},
-	{EVP_PBE_TYPE_OUTER, NID_pbe_WithSHA1And40BitRC2_CBC,
-			NID_rc2_40_cbc, NID_sha1, PKCS12_PBE_keyivgen},
-
-#ifndef OPENSSL_NO_HMAC
-	{EVP_PBE_TYPE_OUTER, NID_pbes2, -1, -1, PKCS5_v2_PBE_keyivgen},
-#endif
-	{EVP_PBE_TYPE_OUTER, NID_pbeWithMD2AndRC2_CBC,
-			NID_rc2_64_cbc, NID_md2, PKCS5_PBE_keyivgen},
-	{EVP_PBE_TYPE_OUTER, NID_pbeWithMD5AndRC2_CBC,
-			NID_rc2_64_cbc, NID_md5, PKCS5_PBE_keyivgen},
-	{EVP_PBE_TYPE_OUTER, NID_pbeWithSHA1AndDES_CBC,
-			NID_des_cbc, NID_sha1, PKCS5_PBE_keyivgen},
-
-
-	{EVP_PBE_TYPE_PRF, NID_hmacWithSHA1, -1, NID_sha1, 0},
-	{EVP_PBE_TYPE_PRF, NID_hmacWithMD5, -1, NID_md5, 0},
-	{EVP_PBE_TYPE_PRF, NID_hmacWithSHA224, -1, NID_sha224, 0},
-	{EVP_PBE_TYPE_PRF, NID_hmacWithSHA256, -1, NID_sha256, 0},
-	{EVP_PBE_TYPE_PRF, NID_hmacWithSHA384, -1, NID_sha384, 0},
-	{EVP_PBE_TYPE_PRF, NID_hmacWithSHA512, -1, NID_sha512, 0},
-	{EVP_PBE_TYPE_PRF, NID_id_HMACGostR3411_94, -1, NID_id_GostR3411_94, 0},
-	};
+#define EVP_PBE_ENTRY( \
+	a_pbe_type,   \
+	a_pbe_nid,    \
+	a_cipher_nid, \
+	a_md_nid,     \
+	a_keygen      \
+) \
+	CONST_PENT_ENTRY( \
+		pbe_type,   a_pbe_type,   \
+		pbe_nid,    a_pbe_nid,    \
+		cipher_nid, a_cipher_nid, \
+		md_nid,     a_md_nid,     \
+		keygen,     a_keygen      \
+	)
+
+OPENSSL_PREFIX_CONST_ARRAY(extern, struct evp_pbe_ctl_st, evp_pbe__builtin_pbe, libopeay)
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_OUTER, NID_pbeWithMD2AndDES_CBC,
+			NID_des_cbc, NID_md2, PKCS5_PBE_keyivgen)
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_OUTER, NID_pbeWithMD5AndDES_CBC,
+			NID_des_cbc, NID_md5, PKCS5_PBE_keyivgen)
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_OUTER, NID_pbeWithSHA1AndRC2_CBC,
+			NID_rc2_64_cbc, NID_sha1, PKCS5_PBE_keyivgen)
+
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_OUTER, NID_pbe_WithSHA1And128BitRC4,
+			NID_rc4, NID_sha1, PKCS12_PBE_keyivgen)
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_OUTER, NID_pbe_WithSHA1And40BitRC4,
+			NID_rc4_40, NID_sha1, PKCS12_PBE_keyivgen)
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_OUTER, NID_pbe_WithSHA1And3_Key_TripleDES_CBC,
+			NID_des_ede3_cbc, NID_sha1, PKCS12_PBE_keyivgen)
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_OUTER, NID_pbe_WithSHA1And2_Key_TripleDES_CBC,
+			NID_des_ede_cbc, NID_sha1, PKCS12_PBE_keyivgen)
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_OUTER, NID_pbe_WithSHA1And128BitRC2_CBC,
+			NID_rc2_cbc, NID_sha1, PKCS12_PBE_keyivgen)
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_OUTER, NID_pbe_WithSHA1And40BitRC2_CBC,
+			NID_rc2_40_cbc, NID_sha1, PKCS12_PBE_keyivgen)
+
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_OUTER, NID_pbeWithMD2AndRC2_CBC,
+			NID_rc2_64_cbc, NID_md2, PKCS5_PBE_keyivgen)
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_OUTER, NID_pbeWithMD5AndRC2_CBC,
+			NID_rc2_64_cbc, NID_md5, PKCS5_PBE_keyivgen)
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_OUTER, NID_pbeWithSHA1AndDES_CBC,
+			NID_des_cbc, NID_sha1, PKCS5_PBE_keyivgen)
+
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_PRF, NID_hmacWithSHA1, -1, NID_sha1, 0)
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_PRF, NID_hmacWithMD5, -1, NID_md5, 0)
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_PRF, NID_hmacWithSHA224, -1, NID_sha224, 0)
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_PRF, NID_hmacWithSHA256, -1, NID_sha256, 0)
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_PRF, NID_hmacWithSHA384, -1, NID_sha384, 0)
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_PRF, NID_hmacWithSHA512, -1, NID_sha512, 0)
+	EVP_PBE_ENTRY(EVP_PBE_TYPE_PRF, NID_id_HMACGostR3411_94, -1, NID_id_GostR3411_94, 0)
+CONST_END(evp_pbe__builtin_pbe)
+#define builtin_pbe OPENSSL_GLOBAL_ARRAY_NAME(evp_pbe__builtin_pbe)
 
 #ifdef TEST
 int main(int argc, char **argv)
@@ -158,18 +181,20 @@
 	if (!EVP_PBE_find(EVP_PBE_TYPE_OUTER, OBJ_obj2nid(pbe_obj),
 					&cipher_nid, &md_nid, &keygen))
 		{
-		char obj_tmp[80];
+		char obj_tmp[80]; /* ARRAY OK 2009-05-25 yngve */
 		EVPerr(EVP_F_EVP_PBE_CIPHERINIT,EVP_R_UNKNOWN_PBE_ALGORITHM);
 		if (!pbe_obj) BUF_strlcpy (obj_tmp, "NULL", sizeof obj_tmp);
 		else i2t_ASN1_OBJECT(obj_tmp, sizeof obj_tmp, pbe_obj);
+#ifndef OPERA_SMALL_VERSION
 		ERR_add_error_data(2, "TYPE=", obj_tmp);
+#endif
 		return 0;
 		}
 
 	if(!pass)
 		passlen = 0;
 	else if (passlen == -1)
-		passlen = strlen(pass);
+		passlen = op_strlen(pass);
 
 	if (cipher_nid == -1)
 		cipher = NULL;
@@ -286,7 +311,7 @@
 	if (pbetmp == NULL)
 		{
 		pbetmp = OBJ_bsearch_pbe2(&pbelu, builtin_pbe,
-				     sizeof(builtin_pbe)/sizeof(EVP_PBE_CTL));
+			OPENSSL_CONST_ARRAY_SIZE(evp_pbe__builtin_pbe));
 		}
 	if (pbetmp == NULL)
 		return 0;
@@ -309,3 +334,5 @@
 	sk_EVP_PBE_CTL_pop_free(pbe_algs, free_evp_pbe_ctl);
 	pbe_algs = NULL;
 	}
+
+#endif // LIBOPEAY_PKCS12_SUPPORT
diff -Naur openssl-1.0.0q.orig/crypto/evp/evp_pkey.c openssl-1.0.0q/crypto/evp/evp_pkey.c
--- openssl-1.0.0q.orig/crypto/evp/evp_pkey.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/evp_pkey.c	2017-04-25 16:23:40.357322785 +0200
@@ -56,12 +56,15 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/x509.h>
 #include <openssl/rand.h>
-#include "asn1_locl.h"
+#include "../asn1/asn1_locl.h"
 
 /* Extract a private key from a PKCS8 structure */
 
@@ -69,7 +72,7 @@
 {
 	EVP_PKEY *pkey = NULL;
 	ASN1_OBJECT *algoid;
-	char obj_tmp[80];
+	char obj_tmp[80]; /* ARRAY OK 2009-05-25 yngve */
 
 	if (!PKCS8_pkey_get0(&algoid, NULL, NULL, NULL, p8))
 		return NULL;
@@ -158,6 +161,7 @@
 	return NULL;
 }
 
+#ifndef OPERA_SMALL_VERSION
 PKCS8_PRIV_KEY_INFO *PKCS8_set_broken(PKCS8_PRIV_KEY_INFO *p8, int broken)
 {
 	switch (broken) {
@@ -178,13 +182,16 @@
 		return NULL;
 	}
 }
+#endif // !OPERA_SMALL_VERSION
 
 /* EVP_PKEY attribute functions */
 
+#ifndef OPERA_SMALL_VERSION
 int EVP_PKEY_get_attr_count(const EVP_PKEY *key)
 {
 	return X509at_get_attr_count(key->attributes);
 }
+#endif // !OPERA_SMALL_VERSION
 
 int EVP_PKEY_get_attr_by_NID(const EVP_PKEY *key, int nid,
 			  int lastpos)
@@ -192,21 +199,25 @@
 	return X509at_get_attr_by_NID(key->attributes, nid, lastpos);
 }
 
+#ifndef OPERA_SMALL_VERSION
 int EVP_PKEY_get_attr_by_OBJ(const EVP_PKEY *key, ASN1_OBJECT *obj,
 			  int lastpos)
 {
 	return X509at_get_attr_by_OBJ(key->attributes, obj, lastpos);
 }
+#endif // !OPERA_SMALL_VERSION
 
 X509_ATTRIBUTE *EVP_PKEY_get_attr(const EVP_PKEY *key, int loc)
 {
 	return X509at_get_attr(key->attributes, loc);
 }
 
+#ifndef OPERA_SMALL_VERSION
 X509_ATTRIBUTE *EVP_PKEY_delete_attr(EVP_PKEY *key, int loc)
 {
 	return X509at_delete_attr(key->attributes, loc);
 }
+#endif // !OPERA_SMALL_VERSION
 
 int EVP_PKEY_add1_attr(EVP_PKEY *key, X509_ATTRIBUTE *attr)
 {
diff -Naur openssl-1.0.0q.orig/crypto/evp/evp_test.c openssl-1.0.0q/crypto/evp/evp_test.c
--- openssl-1.0.0q.orig/crypto/evp/evp_test.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/evp_test.c	2017-04-25 16:23:40.358322353 +0200
@@ -47,8 +47,13 @@
  * OF THE POSSIBILITY OF SUCH DAMAGE.
  */
 
+
+#error("/* ARRAY FILE UNUSED. CHECK ARRAYS BEFORE USING */")
+
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <string.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 #include "../e_os.h"
 
@@ -87,7 +92,7 @@
 	    fprintf(stderr,"Odd number of hex digits!");
 	    EXIT(4);
 	    }
-	sscanf((char *)s,"%2x",&n);
+	op_sscanf((char *)s,"%2x",&n);
 	*d=(unsigned char)n;
 	}
     return s-d;
@@ -101,7 +106,7 @@
     if (**string == 0)
         return NULL;
 
-    memset(isdelim, 0, 256);
+    op_memset(isdelim, 0, 256);
     isdelim[0] = 1;
 
     while (*delim)
@@ -188,7 +193,7 @@
 	    test1_exit(8);
 	    }
 
-	if(memcmp(out,ciphertext,cn))
+	if(op_memcmp(out,ciphertext,cn))
 	    {
 	    fprintf(stderr,"Ciphertext mismatch\n");
 	    hexdump(stderr,"Got",out,cn);
@@ -227,7 +232,7 @@
 	    test1_exit(8);
 	    }
 
-	if(memcmp(out,plaintext,pn))
+	if(op_memcmp(out,plaintext,pn))
 	    {
 	    fprintf(stderr,"Plaintext mismatch\n");
 	    hexdump(stderr,"Got",out,pn);
@@ -302,7 +307,7 @@
 	EXIT(102);
 	}
 
-    if(memcmp(md,ciphertext,cn))
+    if(op_memcmp(md,ciphertext,cn))
 	{
 	fprintf(stderr,"Digest mismatch\n");
 	hexdump(stderr,"Got",md,cn);
@@ -384,7 +389,7 @@
 	    p[-1] = '\0';
 	    encdec = -1;
 	} else {
-	    encdec = atoi(sstrsep(&p,"\n"));
+	    encdec = op_atoi(sstrsep(&p,"\n"));
 	}
 	      
 
diff -Naur openssl-1.0.0q.orig/crypto/evp/m_dss.c openssl-1.0.0q/crypto/evp/m_dss.c
--- openssl-1.0.0q.orig/crypto/evp/m_dss.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/m_dss.c	2017-04-25 16:23:40.359321922 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/evp.h>
 #include <openssl/objects.h>
diff -Naur openssl-1.0.0q.orig/crypto/evp/m_dss1.c openssl-1.0.0q/crypto/evp/m_dss1.c
--- openssl-1.0.0q.orig/crypto/evp/m_dss1.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/m_dss1.c	2017-04-25 16:23:40.360321490 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 
 #ifndef OPENSSL_NO_SHA
 
@@ -67,18 +69,18 @@
 #ifndef OPENSSL_NO_DSA
 #include <openssl/dsa.h>
 #endif
+#include "modules/libopeay/libopeay_arrays.h"
 
 static int init(EVP_MD_CTX *ctx)
-	{ return SHA1_Init(ctx->md_data); }
+	{ return SHA1_Init((SHA_CTX *) ctx->md_data); }
 
 static int update(EVP_MD_CTX *ctx,const void *data,size_t count)
-	{ return SHA1_Update(ctx->md_data,data,count); }
+	{ return SHA1_Update((SHA_CTX *) ctx->md_data,data,count); }
 
 static int final(EVP_MD_CTX *ctx,unsigned char *md)
-	{ return SHA1_Final(md,ctx->md_data); }
+	{ return SHA1_Final(md,(SHA_CTX *) ctx->md_data); }
 
-static const EVP_MD dss1_md=
-	{
+CONST_EVP_MD_ITEM(dss1_md,
 	NID_dsa,
 	NID_dsaWithSHA1,
 	SHA_DIGEST_LENGTH,
@@ -90,11 +92,11 @@
 	NULL,
 	EVP_PKEY_DSA_method,
 	SHA_CBLOCK,
-	sizeof(EVP_MD *)+sizeof(SHA_CTX),
-	};
+	sizeof(EVP_MD *)+sizeof(SHA_CTX)
+	);
 
 const EVP_MD *EVP_dss1(void)
 	{
-	return(&dss1_md);
+	return(&OPENSSL_GLOBAL_ITEM_NAME(dss1_md));
 	}
 #endif
diff -Naur openssl-1.0.0q.orig/crypto/evp/m_md2.c openssl-1.0.0q/crypto/evp/m_md2.c
--- openssl-1.0.0q.orig/crypto/evp/m_md2.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/m_md2.c	2017-04-25 16:23:40.361322176 +0200
@@ -56,8 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 
 #ifndef OPENSSL_NO_MD2
 
@@ -68,18 +71,18 @@
 #ifndef OPENSSL_NO_RSA
 #include <openssl/rsa.h>
 #endif
+#include "modules/libopeay/libopeay_arrays.h"
 
 static int init(EVP_MD_CTX *ctx)
-	{ return MD2_Init(ctx->md_data); }
+	{ return MD2_Init((MD2_CTX *) ctx->md_data); }
 
 static int update(EVP_MD_CTX *ctx,const void *data,size_t count)
-	{ return MD2_Update(ctx->md_data,data,count); }
+	{ return MD2_Update((MD2_CTX *) ctx->md_data, (const unsigned char *) data,count); }
 
 static int final(EVP_MD_CTX *ctx,unsigned char *md)
-	{ return MD2_Final(md,ctx->md_data); }
+	{ return MD2_Final(md,(MD2_CTX *) ctx->md_data); }
 
-static const EVP_MD md2_md=
-	{
+CONST_EVP_MD_ITEM(md2_md,
 	NID_md2,
 	NID_md2WithRSAEncryption,
 	MD2_DIGEST_LENGTH,
@@ -91,11 +94,11 @@
 	NULL,
 	EVP_PKEY_RSA_method,
 	MD2_BLOCK,
-	sizeof(EVP_MD *)+sizeof(MD2_CTX),
-	};
+	sizeof(EVP_MD *)+sizeof(MD2_CTX)
+	);
 
 const EVP_MD *EVP_md2(void)
 	{
-	return(&md2_md);
+	return(&OPENSSL_GLOBAL_ITEM_NAME(md2_md));
 	}
 #endif
diff -Naur openssl-1.0.0q.orig/crypto/evp/m_md4.c openssl-1.0.0q/crypto/evp/m_md4.c
--- openssl-1.0.0q.orig/crypto/evp/m_md4.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/m_md4.c	2017-04-25 16:23:40.361322176 +0200
@@ -56,8 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 
 #ifndef OPENSSL_NO_MD4
 
diff -Naur openssl-1.0.0q.orig/crypto/evp/m_md5.c openssl-1.0.0q/crypto/evp/m_md5.c
--- openssl-1.0.0q.orig/crypto/evp/m_md5.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/m_md5.c	2017-04-25 16:23:40.362322303 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 
 #ifndef OPENSSL_NO_MD5
 
@@ -68,18 +70,18 @@
 #ifndef OPENSSL_NO_RSA
 #include <openssl/rsa.h>
 #endif
+#include "modules/libopeay/libopeay_arrays.h"
 
 static int init(EVP_MD_CTX *ctx)
-	{ return MD5_Init(ctx->md_data); }
+	{ return MD5_Init((MD5_CTX *) ctx->md_data); }
 
 static int update(EVP_MD_CTX *ctx,const void *data,size_t count)
-	{ return MD5_Update(ctx->md_data,data,count); }
+	{ return MD5_Update((MD5_CTX *) ctx->md_data,data,count); }
 
 static int final(EVP_MD_CTX *ctx,unsigned char *md)
-	{ return MD5_Final(md,ctx->md_data); }
+	{ return MD5_Final(md,(MD5_CTX *) ctx->md_data); }
 
-static const EVP_MD md5_md=
-	{
+CONST_EVP_MD_ITEM(md5_md,
 	NID_md5,
 	NID_md5WithRSAEncryption,
 	MD5_DIGEST_LENGTH,
@@ -91,11 +93,11 @@
 	NULL,
 	EVP_PKEY_RSA_method,
 	MD5_CBLOCK,
-	sizeof(EVP_MD *)+sizeof(MD5_CTX),
-	};
+	sizeof(EVP_MD *)+sizeof(MD5_CTX)
+	);
 
 const EVP_MD *EVP_md5(void)
 	{
-	return(&md5_md);
+	return(&OPENSSL_GLOBAL_ITEM_NAME(md5_md));
 	}
 #endif
diff -Naur openssl-1.0.0q.orig/crypto/evp/m_mdc2.c openssl-1.0.0q/crypto/evp/m_mdc2.c
--- openssl-1.0.0q.orig/crypto/evp/m_mdc2.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/m_mdc2.c	2017-04-25 16:23:40.363322151 +0200
@@ -56,8 +56,11 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 
 #ifndef OPENSSL_NO_MDC2
 
diff -Naur openssl-1.0.0q.orig/crypto/evp/m_null.c openssl-1.0.0q/crypto/evp/m_null.c
--- openssl-1.0.0q.orig/crypto/evp/m_null.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/m_null.c	2017-04-25 16:23:40.364322557 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 #include <openssl/evp.h>
 #include <openssl/objects.h>
diff -Naur openssl-1.0.0q.orig/crypto/evp/m_ripemd.c openssl-1.0.0q/crypto/evp/m_ripemd.c
--- openssl-1.0.0q.orig/crypto/evp/m_ripemd.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/m_ripemd.c	2017-04-25 16:23:40.365323243 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 
 #ifndef OPENSSL_NO_RIPEMD
 
@@ -68,18 +70,18 @@
 #ifndef OPENSSL_NO_RSA
 #include <openssl/rsa.h>
 #endif
+#include "modules/libopeay/libopeay_arrays.h"
 
 static int init(EVP_MD_CTX *ctx)
-	{ return RIPEMD160_Init(ctx->md_data); }
+	{ return RIPEMD160_Init((RIPEMD160_CTX *) ctx->md_data); }
 
 static int update(EVP_MD_CTX *ctx,const void *data,size_t count)
-	{ return RIPEMD160_Update(ctx->md_data,data,count); }
+	{ return RIPEMD160_Update((RIPEMD160_CTX *) ctx->md_data,data,count); }
 
 static int final(EVP_MD_CTX *ctx,unsigned char *md)
-	{ return RIPEMD160_Final(md,ctx->md_data); }
+	{ return RIPEMD160_Final(md,(RIPEMD160_CTX *) ctx->md_data); }
 
-static const EVP_MD ripemd160_md=
-	{
+CONST_EVP_MD_ITEM(ripemd160_md,
 	NID_ripemd160,
 	NID_ripemd160WithRSA,
 	RIPEMD160_DIGEST_LENGTH,
@@ -91,11 +93,11 @@
 	NULL,
 	EVP_PKEY_RSA_method,
 	RIPEMD160_CBLOCK,
-	sizeof(EVP_MD *)+sizeof(RIPEMD160_CTX),
-	};
+	sizeof(EVP_MD *)+sizeof(RIPEMD160_CTX)
+	);
 
 const EVP_MD *EVP_ripemd160(void)
 	{
-	return(&ripemd160_md);
+	return(&OPENSSL_GLOBAL_ITEM_NAME(ripemd160_md));
 	}
 #endif
diff -Naur openssl-1.0.0q.orig/crypto/evp/m_sha.c openssl-1.0.0q/crypto/evp/m_sha.c
--- openssl-1.0.0q.orig/crypto/evp/m_sha.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/m_sha.c	2017-04-25 16:23:40.365323243 +0200
@@ -56,7 +56,9 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include "cryptlib.h"
 
 #if !defined(OPENSSL_NO_SHA) && !defined(OPENSSL_NO_SHA0)
diff -Naur openssl-1.0.0q.orig/crypto/evp/m_sha1.c openssl-1.0.0q/crypto/evp/m_sha1.c
--- openssl-1.0.0q.orig/crypto/evp/m_sha1.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/m_sha1.c	2017-04-25 16:23:40.366322253 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 
 #ifndef OPENSSL_NO_SHA
 
@@ -67,18 +69,19 @@
 #ifndef OPENSSL_NO_RSA
 #include <openssl/rsa.h>
 #endif
+#include "modules/libopeay/libopeay_arrays.h"
+
 
 static int init(EVP_MD_CTX *ctx)
-	{ return SHA1_Init(ctx->md_data); }
+	{ return SHA1_Init((SHA_CTX *) ctx->md_data); }
 
 static int update(EVP_MD_CTX *ctx,const void *data,size_t count)
-	{ return SHA1_Update(ctx->md_data,data,count); }
+	{ return SHA1_Update((SHA_CTX *) ctx->md_data,data,count); }
 
 static int final(EVP_MD_CTX *ctx,unsigned char *md)
-	{ return SHA1_Final(md,ctx->md_data); }
+	{ return SHA1_Final(md,(SHA_CTX *) ctx->md_data); }
 
-static const EVP_MD sha1_md=
-	{
+CONST_EVP_MD_ITEM(sha1_md,
 	NID_sha1,
 	NID_sha1WithRSAEncryption,
 	SHA_DIGEST_LENGTH,
@@ -90,32 +93,31 @@
 	NULL,
 	EVP_PKEY_RSA_method,
 	SHA_CBLOCK,
-	sizeof(EVP_MD *)+sizeof(SHA_CTX),
-	};
+	sizeof(EVP_MD *)+sizeof(SHA_CTX)
+	);
 
 const EVP_MD *EVP_sha1(void)
 	{
-	return(&sha1_md);
+	return(&OPENSSL_GLOBAL_ITEM_NAME(sha1_md));
 	}
 #endif
 
 #ifndef OPENSSL_NO_SHA256
 static int init224(EVP_MD_CTX *ctx)
-	{ return SHA224_Init(ctx->md_data); }
+	{ return SHA224_Init((SHA256_CTX *) ctx->md_data); }
 static int init256(EVP_MD_CTX *ctx)
-	{ return SHA256_Init(ctx->md_data); }
+	{ return SHA256_Init((SHA256_CTX *) ctx->md_data); }
 /*
  * Even though there're separate SHA224_[Update|Final], we call
  * SHA256 functions even in SHA224 context. This is what happens
  * there anyway, so we can spare few CPU cycles:-)
  */
 static int update256(EVP_MD_CTX *ctx,const void *data,size_t count)
-	{ return SHA256_Update(ctx->md_data,data,count); }
+	{ return SHA256_Update((SHA256_CTX *) ctx->md_data,data,count); }
 static int final256(EVP_MD_CTX *ctx,unsigned char *md)
-	{ return SHA256_Final(md,ctx->md_data); }
+	{ return SHA256_Final(md,(SHA256_CTX *) ctx->md_data); }
 
-static const EVP_MD sha224_md=
-	{
+CONST_EVP_MD_ITEM(sha224_md,
 	NID_sha224,
 	NID_sha224WithRSAEncryption,
 	SHA224_DIGEST_LENGTH,
@@ -127,14 +129,13 @@
 	NULL,
 	EVP_PKEY_RSA_method,
 	SHA256_CBLOCK,
-	sizeof(EVP_MD *)+sizeof(SHA256_CTX),
-	};
+	sizeof(EVP_MD *)+sizeof(SHA256_CTX)
+	);
 
 const EVP_MD *EVP_sha224(void)
-	{ return(&sha224_md); }
+	{ return(&OPENSSL_GLOBAL_ITEM_NAME(sha224_md)); }
 
-static const EVP_MD sha256_md=
-	{
+CONST_EVP_MD_ITEM(sha256_md,
 	NID_sha256,
 	NID_sha256WithRSAEncryption,
 	SHA256_DIGEST_LENGTH,
@@ -146,26 +147,25 @@
 	NULL,
 	EVP_PKEY_RSA_method,
 	SHA256_CBLOCK,
-	sizeof(EVP_MD *)+sizeof(SHA256_CTX),
-	};
+	sizeof(EVP_MD *)+sizeof(SHA256_CTX)
+	);
 
 const EVP_MD *EVP_sha256(void)
-	{ return(&sha256_md); }
+	{ return(&OPENSSL_GLOBAL_ITEM_NAME(sha256_md)); }
 #endif	/* ifndef OPENSSL_NO_SHA256 */
 
 #ifndef OPENSSL_NO_SHA512
 static int init384(EVP_MD_CTX *ctx)
-	{ return SHA384_Init(ctx->md_data); }
+	{ return SHA384_Init((SHA512_CTX *) ctx->md_data); }
 static int init512(EVP_MD_CTX *ctx)
-	{ return SHA512_Init(ctx->md_data); }
+	{ return SHA512_Init((SHA512_CTX *) ctx->md_data); }
 /* See comment in SHA224/256 section */
 static int update512(EVP_MD_CTX *ctx,const void *data,size_t count)
-	{ return SHA512_Update(ctx->md_data,data,count); }
+	{ return SHA512_Update((SHA512_CTX *) ctx->md_data,data,count); }
 static int final512(EVP_MD_CTX *ctx,unsigned char *md)
-	{ return SHA512_Final(md,ctx->md_data); }
+	{ return SHA512_Final(md,(SHA512_CTX *) ctx->md_data); }
 
-static const EVP_MD sha384_md=
-	{
+CONST_EVP_MD_ITEM(sha384_md,
 	NID_sha384,
 	NID_sha384WithRSAEncryption,
 	SHA384_DIGEST_LENGTH,
@@ -177,14 +177,13 @@
 	NULL,
 	EVP_PKEY_RSA_method,
 	SHA512_CBLOCK,
-	sizeof(EVP_MD *)+sizeof(SHA512_CTX),
-	};
+	sizeof(EVP_MD *)+sizeof(SHA512_CTX)
+	);
 
 const EVP_MD *EVP_sha384(void)
-	{ return(&sha384_md); }
+	{ return(&OPENSSL_GLOBAL_ITEM_NAME(sha384_md)); }
 
-static const EVP_MD sha512_md=
-	{
+CONST_EVP_MD_ITEM(sha512_md,
 	NID_sha512,
 	NID_sha512WithRSAEncryption,
 	SHA512_DIGEST_LENGTH,
@@ -196,9 +195,9 @@
 	NULL,
 	EVP_PKEY_RSA_method,
 	SHA512_CBLOCK,
-	sizeof(EVP_MD *)+sizeof(SHA512_CTX),
-	};
+	sizeof(EVP_MD *)+sizeof(SHA512_CTX)
+	);
 
 const EVP_MD *EVP_sha512(void)
-	{ return(&sha512_md); }
+	{ return(&OPENSSL_GLOBAL_ITEM_NAME(sha512_md)); }
 #endif	/* ifndef OPENSSL_NO_SHA512 */
diff -Naur openssl-1.0.0q.orig/crypto/evp/m_sigver.c openssl-1.0.0q/crypto/evp/m_sigver.c
--- openssl-1.0.0q.orig/crypto/evp/m_sigver.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/m_sigver.c	2017-04-25 16:23:40.367322939 +0200
@@ -56,8 +56,11 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/evp.h>
 #include <openssl/objects.h>
 #include <openssl/x509.h>
@@ -140,6 +143,10 @@
 		EVP_MD_CTX tmp_ctx;
 		unsigned char md[EVP_MAX_MD_SIZE];
 		unsigned int mdlen;
+
+		/* Suppress warning "potentially uninitialized local variable used". */
+		mdlen = 0;
+
 		EVP_MD_CTX_init(&tmp_ctx);
 		if (!EVP_MD_CTX_copy_ex(&tmp_ctx,ctx))
 		     	return 0;
@@ -179,6 +186,9 @@
 	unsigned int mdlen;
 	int vctx;
 
+	/* Suppress warning "potentially uninitialized local variable used". */
+	mdlen = 0;
+
 	if (ctx->pctx->pmeth->verifyctx)
 		vctx = 1;
 	else
diff -Naur openssl-1.0.0q.orig/crypto/evp/names.c openssl-1.0.0q/crypto/evp/names.c
--- openssl-1.0.0q.orig/crypto/evp/names.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/names.c	2017-04-25 16:23:40.368322507 +0200
@@ -56,8 +56,10 @@
  * [including the GNU Public Licence.]
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/evp.h>
 #include <openssl/objects.h>
 #include <openssl/x509.h>
@@ -123,7 +125,10 @@
 	   does that part.  -- Richard Levitte */
 	OBJ_NAME_cleanup(-1);
 
+#if !defined(_SSL_USE_OPENSSL_) && !defined(USE_OPENSSL_CERTIFICATE_VERIFICATION)
 	EVP_PBE_cleanup();
+#endif
+
 	if (obj_cleanup_defer == 2)
 		{
 		obj_cleanup_defer = 0;
@@ -141,7 +146,7 @@
 
 static void do_all_cipher_fn(const OBJ_NAME *nm, void *arg)
 	{
-	struct doall_cipher *dc = arg;
+	struct doall_cipher *dc = (struct doall_cipher *)arg;
 	if (nm->alias)
 		dc->fn(NULL, nm->name, nm->data, dc->arg);
 	else
@@ -175,7 +180,7 @@
 
 static void do_all_md_fn(const OBJ_NAME *nm, void *arg)
 	{
-	struct doall_md *dc = arg;
+	struct doall_md *dc = (struct doall_md *)arg;
 	if (nm->alias)
 		dc->fn(NULL, nm->name, nm->data, dc->arg);
 	else
diff -Naur openssl-1.0.0q.orig/crypto/evp/openbsd_hw.c openssl-1.0.0q/crypto/evp/openbsd_hw.c
--- openssl-1.0.0q.orig/crypto/evp/openbsd_hw.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/openbsd_hw.c	2017-04-25 16:23:40.369322634 +0200
@@ -61,13 +61,19 @@
 /* check flag after OpenSSL headers to ensure make depend works */
 #ifdef OPENSSL_OPENBSD_DEV_CRYPTO
 
+#ifndef OPERA_SMALL_VERSION
 #include <fcntl.h>
+#endif /* !OPERA_SMALL_VERSION */
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <errno.h>
+#endif /* !OPERA_SMALL_VERSION */
 #include <sys/ioctl.h>
 #include <crypto/cryptodev.h>
 #include <unistd.h>
+#ifndef OPERA_SMALL_VERSION
 #include <assert.h>
+#endif /* !OPERA_SMALL_VERSION */
 
 /* longest key supported in hardware */
 #define MAX_HW_KEY	24
@@ -112,7 +118,7 @@
 	close(cryptodev_fd);
 	}
     assert(ses);
-    memset(ses,'\0',sizeof *ses);
+    op_memset(ses,'\0',sizeof *ses);
 
     return 1;
     }
@@ -137,7 +143,7 @@
 
     assert(ctx->cipher->iv_len <= MAX_HW_IV);
 
-    memcpy(CDATA(ctx)->key,key,klen);
+    op_memcpy(CDATA(ctx)->key,key,klen);
     
     CDATA(ctx)->cipher=cipher;
     CDATA(ctx)->keylen=klen;
@@ -162,7 +168,7 @@
     assert(CDATA(ctx));
     assert(!dev_failed);
 
-    memset(&cryp,'\0',sizeof cryp);
+    op_memset(&cryp,'\0',sizeof cryp);
     cryp.ses=CDATA(ctx)->ses;
     cryp.op=ctx->encrypt ? COP_ENCRYPT : COP_DECRYPT;
     cryp.flags=0;
@@ -175,7 +181,7 @@
 	cryp.iv=(caddr_t)ctx->iv;
 
     if(!ctx->encrypt)
-	memcpy(lb,&in[cryp.len-ctx->cipher->iv_len],ctx->cipher->iv_len);
+	op_memcpy(lb,&in[cryp.len-ctx->cipher->iv_len],ctx->cipher->iv_len);
 
     if(ioctl(fd, CIOCCRYPT, &cryp) == -1)
 	{
@@ -191,7 +197,7 @@
 	    if(((unsigned long)in&3) || cinl != inl)
 		{
 		cin=OPENSSL_malloc(cinl);
-		memcpy(cin,in,inl);
+		op_memcpy(cin,in,inl);
 		cryp.src=cin;
 		}
 
@@ -213,7 +219,7 @@
 		
 	    if(cout)
 		{
-		memcpy(out,cout,inl);
+		op_memcpy(out,cout,inl);
 		OPENSSL_free(cout);
 		}
 	    if(cin)
@@ -228,9 +234,9 @@
 	}
 
     if(ctx->encrypt)
-	memcpy(ctx->iv,&out[cryp.len-ctx->cipher->iv_len],ctx->cipher->iv_len);
+	op_memcpy(ctx->iv,&out[cryp.len-ctx->cipher->iv_len],ctx->cipher->iv_len);
     else
-	memcpy(ctx->iv,lb,ctx->cipher->iv_len);
+	op_memcpy(ctx->iv,lb,ctx->cipher->iv_len);
 
     return 1;
     }
@@ -325,16 +331,16 @@
     /* some cards can't do zero length */
     if(!len)
 	{
-	memcpy(md,md5zero,16);
+	op_memcpy(md,md5zero,16);
 	return 1;
 	}
 
-    memset(&cryp,'\0',sizeof cryp);
+    op_memset(&cryp,'\0',sizeof cryp);
     cryp.ses=ses;
     cryp.op=COP_ENCRYPT;/* required to do the MAC rather than check it */
     cryp.len=len;
     cryp.src=(caddr_t)data;
-    cryp.dst=(caddr_t)data; // FIXME!!!
+    cryp.dst=(caddr_t)data; /*FIXME!!! */
     cryp.mac=(caddr_t)md;
 
     if(ioctl(fd, CIOCCRYPT, &cryp) == -1)
@@ -344,9 +350,9 @@
 	    char *dcopy;
 
 	    dcopy=OPENSSL_malloc(len);
-	    memcpy(dcopy,data,len);
+	    op_memcpy(dcopy,data,len);
 	    cryp.src=dcopy;
-	    cryp.dst=cryp.src; // FIXME!!!
+	    cryp.dst=cryp.src; /*FIXME!!! */
 
 	    if(ioctl(fd, CIOCCRYPT, &cryp) == -1)
 		{
@@ -363,7 +369,7 @@
 	    return 0;
 	    }
 	}
-    //    printf("done\n");
+    /*   printf("done\n"); */
 
     return 1;
     }
@@ -377,7 +383,7 @@
 	return do_digest(md_data->sess.ses,md_data->md,data,len);
 
     md_data->data=OPENSSL_realloc(md_data->data,md_data->len+len);
-    memcpy(md_data->data+md_data->len,data,len);
+    op_memcpy(md_data->data+md_data->len,data,len);
     md_data->len+=len;
 
     return 1;
@@ -390,7 +396,7 @@
 
     if(ctx->flags&EVP_MD_CTX_FLAG_ONESHOT)
 	{
-	memcpy(md,md_data->md,MD5_DIGEST_LENGTH);
+	op_memcpy(md,md_data->md,MD5_DIGEST_LENGTH);
 	ret=1;
 	}
     else
@@ -409,11 +415,11 @@
     const MD_DATA *from_md=from->md_data;
     MD_DATA *to_md=to->md_data;
 
-    // How do we copy sessions?
+    /*How do we copy sessions? */
     assert(from->digest->flags&EVP_MD_FLAG_ONESHOT);
 
     to_md->data=OPENSSL_malloc(from_md->len);
-    memcpy(to_md->data,from_md->data,from_md->len);
+    op_memcpy(to_md->data,from_md->data,from_md->len);
 
     return 1;
     }
diff -Naur openssl-1.0.0q.orig/crypto/evp/p5_crpt.c openssl-1.0.0q/crypto/evp/p5_crpt.c
--- openssl-1.0.0q.orig/crypto/evp/p5_crpt.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/p5_crpt.c	2017-04-25 16:23:40.423620038 +0200
@@ -56,9 +56,12 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+
+#include <openssl/cryptlib.h>
 #include <openssl/x509.h>
 #include <openssl/evp.h>
 
@@ -102,7 +105,7 @@
 	saltlen = pbe->salt->length;
 
 	if(!pass) passlen = 0;
-	else if(passlen == -1) passlen = strlen(pass);
+	else if(passlen == -1) passlen = op_strlen(pass);
 
 	EVP_MD_CTX_init(&ctx);
 	EVP_DigestInit_ex(&ctx, md, NULL);
@@ -120,9 +123,9 @@
 	}
 	EVP_MD_CTX_cleanup(&ctx);
 	OPENSSL_assert(EVP_CIPHER_key_length(cipher) <= (int)sizeof(md_tmp));
-	memcpy(key, md_tmp, EVP_CIPHER_key_length(cipher));
+	op_memcpy(key, md_tmp, EVP_CIPHER_key_length(cipher));
 	OPENSSL_assert(EVP_CIPHER_iv_length(cipher) <= 16);
-	memcpy(iv, md_tmp + (16 - EVP_CIPHER_iv_length(cipher)),
+	op_memcpy(iv, md_tmp + (16 - EVP_CIPHER_iv_length(cipher)),
 						 EVP_CIPHER_iv_length(cipher));
 	EVP_CipherInit_ex(cctx, cipher, NULL, key, iv, en_de);
 	OPENSSL_cleanse(md_tmp, EVP_MAX_MD_SIZE);
diff -Naur openssl-1.0.0q.orig/crypto/evp/p5_crpt2.c openssl-1.0.0q/crypto/evp/p5_crpt2.c
--- openssl-1.0.0q.orig/crypto/evp/p5_crpt2.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/evp/p5_crpt2.c	2017-04-25 16:23:40.424620444 +0200
@@ -55,9 +55,11 @@
  * Hudson (tjh@cryptsoft.com).
  *
  */
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
 #include <stdlib.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #if !defined(OPENSSL_NO_HMAC) && !defined(OPENSSL_NO_SHA)
 #include <openssl/x509.h>
 #include <openssl/evp.h>
@@ -96,7 +98,7 @@
 	if(!pass)
 		passlen = 0;
 	else if(passlen == -1)
-		passlen = strlen(pass);
+		passlen = op_strlen(pass);
 	if (!HMAC_Init_ex(&hctx_tpl, pass, passlen, digest, NULL))
 		{
 		HMAC_CTX_cleanup(&hctx_tpl);
@@ -129,7 +131,7 @@
 			return 0;
 			}
 		HMAC_CTX_cleanup(&hctx);
-		memcpy(p, digtmp, cplen);
+		op_memcpy(p, digtmp, cplen);
 		for(j = 1; j < iter; j++)
 			{
 			if (!HMAC_CTX_copy(&hctx, &hctx_tpl))
